#
#

PROGRAMS=vre_demo
VRELIB=libvre.a
STRCASELIB=libstrcasecmp.a

#Where to find strcasecmp
ORIGCASELIB=/usr/ucblib/libucb.a
ORIGCASEOBJ=stricmp

#On sequents (ptx 2/3) the case insensitive strings comparison is in the network
#libary. So get it from there.
#ORIGCASELIB=/usr/lib/libinet.a
#ORIGCASEOBJ=strcasecmp

#Some machines require that the local directory be specified for <something.h>
INCDIR=-I.

#Generic compiler flags (ansi mode on)
CFLAGS= -Xc $(INCDIR)

#NCR Metaware High C compiler flags
#CFLAGS=-Hnocopyr -Xc

#GNU C
#CC=gcc
#CFLAGS=-ansi -Wall -I.


all:: $(PROGRAMS)

vre_demo: vre_demo.o $(VRELIB) $(STRCASELIB)
	cc -o vre_demo vre_demo.o $(VRELIB) $(STRCASELIB)

vre_demo.o: vre_demo.c

$(VRELIB): $(VRELIB)(GWYC0221.o) \
	    $(VRELIB)(GWYC0222.o) \
	    $(VRELIB)(GWYC0223.o) \
	    $(VRELIB)(GWYC0224.o) \
	    $(VRELIB)(GWYC0202.o) \
	    $(VRELIB)(GWYC0204.o) \
	    $(VRELIB)(GWYC0205.o) \
	    $(VRELIB)(GWYC0206.o) \
	    $(VRELIB)(GWYC0201.o) \
	    $(VRELIB)(GWYC0207.o) \
	    $(VRELIB)(GWYC0208.o) \
	    $(VRELIB)(RESC1651.o)

$(VRELIB)(GWYC0221.o): GWYC0221.c GWYC0220.h
$(VRELIB)(GWYC0222.o): GWYC0222.c GWYC0220.h
$(VRELIB)(GWYC0223.o): GWYC0223.c GWYC0220.h
$(VRELIB)(GWYC0224.o): GWYC0224.c GWYC0220.h

$(STRCASELIB): $(STRCASELIB)($(ORIGCASEOBJ).o)

$(STRCASELIB)($(ORIGCASEOBJ).o): $(ORIGCASEOBJ).o
	ar r $@ $%

$(ORIGCASEOBJ).o:
	ar x $(ORIGCASELIB) $(ORIGCASEOBJ).o


SRCFILES= vre_demo.c vre_demo.dat

clean ::
	-rm -f *.o ${VRELIB} ${STRCASELIB} ${PROGRAMS}


