/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/bpo_val_res.c,v $
*  $Author: mpoole $
*  $Date: 2002/10/07 09:37:37 $
*  $Revision: 1.2 $
*
*******************************************************************************
*
* Change History
*
* $Log: bpo_val_res.c,v $
* Revision 1.2  2002/10/07 09:37:37  mpoole
* Initial checkin of mplib1-3.1.0
*
* Revision 1.1  2002/10/07 09:36:54  mpoole
* Initial checkin of mplib1-3.1.0
*
*
*******************************************************************************
*/

#ident "$Header: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/bpo_val_res.c,v 1.2 2002/10/07 09:37:37 mpoole Exp $"

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdarg.h>
#include <memory.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#include <mplib1/mplib1_config.h>
#include <mplib1/dl_list.h>
#include "../include/bpo_init_internal.h"
#include "../include/bpo_alloc_private.h"
#include <mplib1/bpo_alloc.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    structures
   ------------------------------------------------------------------ */

struct procwalk
{
int		which_procs;
Validate_Resource_t	isp_disp;
struct	sodb	*sodbp;
void		*f_param1;
};

/* ------------------------------------------------------------------
    static variables
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

static void
res_check_proc( void *vp1, void *vp2 )
{
    struct sodb_resource *sodbrp;
    struct procwalk *pw;
    char *res_name;

    sodbrp = vp1;
    pw = vp2;
    res_name = GRPTR( &sodbrp->res_node.lno_me, sodbrp->res_node.lno_Name );

    (* pw->isp_disp)( res_name, sodbrp->res_off, pw->f_param1 );
    return;
}

int
Validate_Resources( const void * hint,
		    int p_which_procs,
		    Validate_Resource_t disp,
		    void *param1 )
{
    /* OK, so walk the resource list and call the routine for each
       resource that we find */
    struct sodb *sodbp;
    struct procwalk myprocwalk;
    int rv=0;

    sodbp = Get_SODB_Base( hint );
    if (sodbp == NULL)
	return(rv);

    myprocwalk.which_procs = p_which_procs;
    myprocwalk.sodbp = sodbp;
    myprocwalk.isp_disp = disp;
    myprocwalk.f_param1 = param1;

    bpo_pid_Lock( &sodbp->res_p_lock );
    bpo_Walk_List( &sodbp->sodb_resource_list, res_check_proc, &myprocwalk );
    bpo_pid_Unlock( &sodbp->res_p_lock );
    return(0);
}

/* -- End of File -- */
