/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/cfg_f_002.c,v $
*  $Author: mpoole $
*  $Date: 2002/10/07 09:37:37 $
*  $Revision: 1.2 $
*
*******************************************************************************
*
* Change History
*
* $Log: cfg_f_002.c,v $
* Revision 1.2  2002/10/07 09:37:37  mpoole
* Initial checkin of mplib1-3.1.0
*
* Revision 1.1  2002/10/07 09:36:54  mpoole
* Initial checkin of mplib1-3.1.0
*
*
*******************************************************************************
*/

#ident "$Header: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/cfg_f_002.c,v 1.2 2002/10/07 09:37:37 mpoole Exp $"

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#include <mplib1/mplib1_config.h>
#include <mplib1/safe_string.h>
#include <mplib1/dl_list.h>
#include <mplib1/cfg_file.h>
#include <include/cfg_file_internal.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

static struct config_item *
Alloc_Item( const char *key, const char *val )
{
    struct config_item *cip;
    int slen;
    char *cp;

    slen = Sstrlen(val) + 1;
    cip = malloc( sizeof(struct config_item) + Sstrlen(key) + slen );
    if (cip)
    {
	cp = cip->ci_val + slen;
	Sstrcpy( cip->ci_val, val );
	Sstrcpy( cp, key );
	cip->eval_str=NULL;
	(void)dl_Init_Node( &cip->ci_Node, cp, cip );
    }
    return(cip);
}

int
set_private_string( const char *list_name, const char *key, const char *val )
{
    struct config_list *clp;
    struct config_item *cip;
    int rv=0;

    clp = get_config_list( list_name, 1 );
    if (clp)
    {
	cip = (struct config_item *)dl_Find_Item_By_Name( &clp->cl_Items, key );
	if (cip==NULL || Sstrlen(cip->ci_val) < Sstrlen(val))
	{
	    if (cip)
	    {
		(void)dl_Remove_Node( &cip->ci_Node );
		free( cip );
	    }
	    cip = Alloc_Item( key, val );
	    if (cip)
	    {
		(void)dl_Add_Head( &clp->cl_Items, &cip->ci_Node );
		rv=1;
	    }
	}else
	{
	    /* replace the existing text */
	    Sstrcpy( cip->ci_val, val );
	    rv=1;
	}
    }
    return(rv);
}

/* -- End of File -- */
