/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/dl_l_001.c,v $
*  $Author: mpoole $
*  $Date: 2002/10/07 09:37:38 $
*  $Revision: 1.2 $
*  Purpose        : Double-linked list handling
*
*******************************************************************************
*
* Change History
*
* $Log: dl_l_001.c,v $
* Revision 1.2  2002/10/07 09:37:38  mpoole
* Initial checkin of mplib1-3.1.0
*
* Revision 1.1  2002/10/07 09:36:55  mpoole
* Initial checkin of mplib1-3.1.0
*
*
*******************************************************************************
*/

#ident "$Header: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/dl_l_001.c,v 1.2 2002/10/07 09:37:38 mpoole Exp $"

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdlib.h>
#include <string.h>
#include <memory.h>

#include <mplib1/mplib1_config.h>

#include <mplib1/dl_list.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

dl_Node_t *
dl_Init_Node( dl_Node_t *node, char *name, void *item )
{
    node->ln_Succ = NULL;
    node->ln_Pred = NULL;
    node->ln_Name = name;
    node->ln_Item = item;
    node->ln_List = NULL;
    return(node);
}

dl_List_t *
dl_Init_List( dl_List_t *list, int flags )
{
    if (list)
    {
	(void)dl_Init_Node( &list->ln_Head, NULL, NULL );
	(void)dl_Init_Node( &list->ln_Tail, NULL, NULL );
	list->ln_Head.ln_List = list;
	list->ln_Tail.ln_List = list;
	list->ln_Flags = flags;
	list->ln_Head.ln_Pred = NULL;
	list->ln_Head.ln_Succ = &list->ln_Tail;
	list->ln_Tail.ln_Pred = &list->ln_Head;
	list->ln_Tail.ln_Succ = NULL;
    }
    return(list);
}

/* -- End of File -- */
