/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/dl_l_015.c,v $
*  $Author: mpoole $
*  $Date: 2002/10/07 09:37:38 $
*  $Revision: 1.2 $
*  Purpose        : Double-linked list handling
*
*******************************************************************************
*
* Change History
*
* $Log: dl_l_015.c,v $
* Revision 1.2  2002/10/07 09:37:38  mpoole
* Initial checkin of mplib1-3.1.0
*
* Revision 1.1  2002/10/07 09:36:56  mpoole
* Initial checkin of mplib1-3.1.0
*
*
*******************************************************************************
*/

#ident "$Header: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/dl_l_015.c,v 1.2 2002/10/07 09:37:38 mpoole Exp $"

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdlib.h>
#include <string.h>
#include <memory.h>

#include <mplib1/mplib1_config.h>

#include <mplib1/dl_list.h>
#include <mplib1/stricmp.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

int
dl_Walk_List_Name( dl_List_t *l_ptr,
		const char *name,
		dl_Walk_List_Name_t disp,
		void *param )
{
    dl_Node_t *n_ptr,*nn_ptr;
    int rv=0,ic;

    n_ptr = l_ptr->ln_Head.ln_Succ;
    ic = (l_ptr->ln_Flags & LN_IGNORECASE);

    while (n_ptr->ln_Succ && rv==0 )
    {
	/* save the next pointer just in case they mash the list */
	nn_ptr = n_ptr->ln_Succ;
	if (   (ic && stricmp(name,n_ptr->ln_Name)==0)
	    || (!ic && strcmp(name,n_ptr->ln_Name)==0)
	   )
	    rv = (*disp)( (void *)n_ptr->ln_Item, param );
	if (n_ptr == nn_ptr)
	    break;
	n_ptr = nn_ptr;
    };
    return(rv);
}

/* -- End of File -- */
