/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/mpbasename.c,v $
*  $Author: mpoole $
*  $Date: 2002/10/07 09:37:39 $
*  $Revision: 1.2 $
*
*******************************************************************************
*
* Change History
*
* $Log: mpbasename.c,v $
* Revision 1.2  2002/10/07 09:37:39  mpoole
* Initial checkin of mplib1-3.1.0
*
* Revision 1.1  2002/10/07 09:36:57  mpoole
* Initial checkin of mplib1-3.1.0
*
*
*******************************************************************************
*/

#ident "$Header: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/mpbasename.c,v 1.2 2002/10/07 09:37:39 mpoole Exp $"

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <mplib1/mplib1_config.h>

#include <mplib1/mpbasename.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

/* ---------------------------------------------------------------------------
   Function                 : mpbasename
   Summary                  : This function returns a pointer to the base name
                            : of the filename given
   Input Parameters         : pointer to a filename
   Output Parameters        : None
   Global Variables         : None
   Return Value             : pointer to basename of filename
   --------------------------------------------------------------------------*/
char *
mpbasename ( const char *full_name )
{
    char *cp;

    cp = (char *)full_name + strlen(full_name) - 1;
    while ( cp > full_name && *cp != '/' ) cp --;
    if ( *cp == '/' ) cp++;
    return(cp);
}



/* -- End of File -- */
