/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/stricmp.c,v $
*  $Author: mpoole $
*  $Date: 2002/10/07 09:37:40 $
*  $Revision: 1.2 $
*  Purpose        :  Case insensitive string comparison ala strcasecmp
*
*******************************************************************************
*
* Change History
*
* $Log: stricmp.c,v $
* Revision 1.2  2002/10/07 09:37:40  mpoole
* Initial checkin of mplib1-3.1.0
*
* Revision 1.1  2002/10/07 09:36:57  mpoole
* Initial checkin of mplib1-3.1.0
*
*
*******************************************************************************
*/

#ident "$Header: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/stricmp.c,v 1.2 2002/10/07 09:37:40 mpoole Exp $"

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdlib.h>
#include <string.h>

#include <mplib1/mplib1_config.h>
#include <mplib1/safe_string.h>
#include <mplib1/stricmp.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

int
stricmp( const char *str1, const char *str2 )
{
    int i, minlen, offset1, offset2;

    if(!str1 || !str2)
    {
	/* Don't want to dereference NULL pointers */
	if(!str1 && !str2)
	    return 0;
	else if (!str1)
	    return -1;
	else
	    return 1;
    }

    /* find shortest to string to make sure we don't go past null */
    minlen = Sstrlen(str1);
    if( (i=Sstrlen(str2)) < minlen)
	minlen = i;

    for(i=0;i<=minlen;i++)
    {
	/* use offsets to make everything lower case */
	offset1 = (str1[i]>='A' && str1[i]<='Z') ? 32:0;
	offset2 = (str2[i]>='A' && str2[i]<='Z') ? 32:0;

	if(str1[i]+offset1<str2[i]+offset2)
	    return -1;
	if(str1[i]+offset1>str2[i]+offset2)
	    return 1;
    }
    /* they're equal */
    return 0;
}

/* -- End of File -- */
