#ifndef MPLIB1_STOPWATCH
#define MPLIB1_STOPWATCH
/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source: /home/cvs/cvsroot/onelan/onelan/src/mplib1/mplib1/stopwatch.h,v $
*  $Author: mpoole $
*  $Date: 2002/10/07 09:37:44 $
*  $Revision: 1.2 $
*
*******************************************************************************
*
* Change History
*
* $Log: stopwatch.h,v $
* Revision 1.2  2002/10/07 09:37:44  mpoole
* Initial checkin of mplib1-3.1.0
*
* Revision 1.1  2002/10/07 09:37:00  mpoole
* Initial checkin of mplib1-3.1.0
*
*
*******************************************************************************
*/

#ident "$Header: /home/cvs/cvsroot/onelan/onelan/src/mplib1/mplib1/stopwatch.h,v 1.2 2002/10/07 09:37:44 mpoole Exp $"

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

#define STOPWATCH_ELPS_SIZE	40
#define CPUSTOPWATCH_ELPS_SIZE	100

#define STOPWATCH_BASE_CENTIS	0x00
#define STOPWATCH_BASE_MILLIS	0x01
#define STOPWATCH_BASE_MICROS	0x02
#define STOPWATCH_BASE_FMASK	0x03

#define STOPWATCH_BASE_SECS	0x00
#define STOPWATCH_BASE_DAYS	0x10
#define STOPWATCH_BASE_SMASK	0x30

#define STOPWATCH_SECS_CENTIS	(STOPWATCH_BASE_SECS|STOPWATCH_BASE_CENTIS)
#define STOPWATCH_SECS_MILLIS	(STOPWATCH_BASE_SECS|STOPWATCH_BASE_MILLIS)
#define STOPWATCH_SECS_MICROS	(STOPWATCH_BASE_SECS|STOPWATCH_BASE_MICROS)

#define STOPWATCH_DAYS_CENTIS	(STOPWATCH_BASE_DAYS|STOPWATCH_BASE_CENTIS)
#define STOPWATCH_DAYS_MILLIS	(STOPWATCH_BASE_DAYS|STOPWATCH_BASE_MILLIS)
#define STOPWATCH_DAYS_MICROS	(STOPWATCH_BASE_DAYS|STOPWATCH_BASE_MICROS)


struct stopwatch
{
struct	timeval start_time;
struct	timeval cumulative_time;
char	elps_str[STOPWATCH_ELPS_SIZE];
};

struct cpu_stopwatch
{
struct	stopwatch	u_timing;
struct	stopwatch	s_timing;
char	elps_str[CPUSTOPWATCH_ELPS_SIZE];
};


#define STOPWATCH_SIZE		sizeof(struct stopwatch)
#define CPU_STOPWATCH_SIZE	sizeof(struct cpu_stopwatch)

#ifndef SECS_PER_DAY
#define SECS_PER_DAY 86400
#endif

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

extern void diff_timevals( struct timeval *end_p, struct timeval *start_p );
extern void add_timevals( struct timeval *cump, struct timeval *tvp );
extern void accum_stop_timevals( struct stopwatch *stp, struct timeval *etp );

extern int init_stopwatch( struct stopwatch *stp );

extern int start_stopwatch( struct stopwatch *stp );

extern int stop_stopwatch( struct stopwatch *stp );

extern int
accrete_stopwatch( struct stopwatch *stp_into, struct stopwatch *stp_from );

extern char *display_stopwatch( struct stopwatch *stp, int mode );

extern int init_cpu_stopwatch( struct cpu_stopwatch *cpu_p );
extern int start_cpu_stopwatch( struct cpu_stopwatch *cpu_p );
extern int stop_cpu_stopwatch( struct cpu_stopwatch *cpu_p );
extern int
accrete_cpu_stopwatch( struct cpu_stopwatch *stp_into,
			struct cpu_stopwatch *stp_from );

extern char *display_cpu_stopwatch( struct cpu_stopwatch *stp, int mode );


#endif
/* -- End of File -- */
