/*
*******************************************************************************
*  Copyright (c) 1997 Martin Poole
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source: /home/cvs/cvsroot/onelan/onelan/src/mplib1/test/lock_test.c,v $
*  $Author: mpoole $
*  $Date: 2002/10/07 09:37:28 $
*  $Revision: 1.2 $
*
*******************************************************************************
*
* Change History
*
* $Log: lock_test.c,v $
* Revision 1.2  2002/10/07 09:37:28  mpoole
* Initial checkin of mplib1-3.1.0
*
* Revision 1.1  2002/10/07 09:37:06  mpoole
* Initial checkin of mplib1-3.1.0
*
*
*******************************************************************************
*/

#ident "$Header: /home/cvs/cvsroot/onelan/onelan/src/mplib1/test/lock_test.c,v 1.2 2002/10/07 09:37:28 mpoole Exp $"

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <memory.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <sys/ipc.h>
#include <signal.h>

#include <mplib1/dl_list.h>
#include <mplib1/pid_check.h>
#include <mplib1/cfg_file.h>
#include "include/bpo_init_internal.h"
#include "include/bpo_q_internal.h"
#include "include/bpo_proc_internal.h"
#include <mplib1/daemon.h>
#include <mplib1/bpo_proc.h>
#include <mplib1/bpo_queue.h>
#include <mplib1/fprintfile.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/*
Lock test code
        set stderr.

        :restart_point
        fork()
        parent dies.
        if parent_pid set, wait for parent to die.
        register self.
        set parent_pid = getpid()
        clean process.
        clean queues.
        Check for bad queue list, die if bad.
        Create 'n' queues (some Q_NM_NONE, some Q_NM_PIPE)
        Craete 'n' messages.
        Post messages to queues.
        goto restart_point.

*/


struct l_test
{
struct	bpo_pid_lock	l_test1;
};

static char lt_str[]="LOCK_TEST";

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

static void
lt_init( struct l_test *ltptr )
{
    bpo_Init_pid_lock( &ltptr->l_test1, NULL );
    return;
}

static void
do_lock_test( void *hint )
{
    struct l_test *ltptr;
    int t;
    ltptr = Fetch_SODB_Resource( hint, lt_str,
				sizeof(struct l_test),
				(Fetch_SODB_Resource_t)lt_init );
    if (ltptr)
    {
	/* First we lock the structure */
	fprintfile(stderr, "** 111 ** Parent: about to lock \n" );
	bpo_pid_Lock( &ltptr->l_test1 );
	fprintfile(stderr, "** 111 ** Parent: about to fork \n" );
	t = fork();
	if (t==0) /* We are child */
	{
	    fprintfile(stderr, "** 222 ** Child: about to attempt lock\n" );
	    bpo_pid_Lock( &ltptr->l_test1 );
	    fprintfile(stderr, "** 444 ** Child: acquired lock\n" );
	    bpo_pid_Unlock( &ltptr->l_test1 );
	}else
	{
	    /* assume success */
	    fprintfile(stderr, "** 222 ** Parent: about to snooze\n" );
	    sleep(5);
	    fprintfile(stderr, "** 333 ** Parent: about to exit\n" );
	    exit(0);
	}
    }else
    {
	fprintfile(stderr, "Unable to allocate test resoruce\n" );
    }
    return;
}

int
main( int argc, char *argv[] )
{
    void *hint;
    char *shm_name,*e_nm=NULL;
    char *cp=NULL;
    int optc,lpcnt=3;

/*    set_config_string( "STDERR", "q_test.err" );*/
    while ((optc = getopt(argc, argv, "e:c:f:")) != EOF)
    switch(optc)
    {
    case 'e' : /* Specify config file */
	e_nm =optarg;
	break;
    case 'f' : /* Specify config file */
	read_config_file(cp=optarg);
	break;
    case 'c' : /* Count */
	lpcnt=atoi(optarg);
	break;
    default:
/*	usage( argv[0], "Invalid argument supplied" );*/
	break;
    }
    if (cp==NULL)
    {
	cp = eval_config_default( NULL, "$HOME/config/q_test.cfg" );
	read_config_file( cp );
    }
    if (e_nm)
    {
	set_config_string( "STDERR", e_nm );
    }

    shm_name = strdup(eval_config_default( "SHM_CONFIG", "$HOME/config/shm.cfg" ));
    hint = comms_shm_attach( shm_name, SODB_READ_CONFIG );
    fprintfile(stderr,"Attach returned: %p\n", hint );
    if (hint)
    {
	/* Force the debugging of the locking on */
	set_config_flag( "BPO_LOCK_DEBUG", 1 );
	do_lock_test( hint );
    }
    return(0);
}

/* -- End of File -- */
